/*
 * clothtex.pov - Cloth Texture Demo
 * 
 * This is only a sample scene file.  There should be a file
 * clothtex.inc with this file.  It contains the ClothTex Macros.
 *
 * ClothTex v0.11 
 *
 * POV-Ray 3.5 macros for Woven Cloth Texture
 * by Kedar Patil <kedar@patilkedar.com>
 *
 */


#include "colors.inc"
#include "clothtex.inc"

background{ rgb 1 }

camera
{
    location <0, 4.5, -6.5>
    look_at  <0, 1, 2.0>

    angle 45
}

global_settings
{
    max_trace_level 10
}


light_source
{
    <0,34,-44>

    color White 
}

light_source
{
    <43,97,15>

    color rgb<0.9, 0.8, 0.7>
}


/*************************************************************
  First Texture
**************************************************************/

#declare XColorArray = array[8]
{
    Red,
    Red,
    Red,
    Red,
    White,
    White,
    White,
    White
}

#declare YColorArray = array[8]
{
    Red,
    Red,
    Red,
    Red,
    White,
    White,
    White,
    White
}
    
    
#declare ClothWeaveArray = array[8][8]
{
    {1, 0, 1, 0, 1, 0, 1, 0},
    {0, 1, 0, 1, 0, 1, 0, 1},
    {1, 0, 1, 0, 1, 0, 1, 0},
    {0, 1, 0, 1, 0, 1, 0, 1},
    {1, 0, 1, 0, 1, 0, 1, 0},
    {0, 1, 0, 1, 0, 1, 0, 1},
    {1, 0, 1, 0, 1, 0, 1, 0},
    {0, 1, 0, 1, 0, 1, 0, 1}
}


#declare ClothPigment1=
MakeClothPigment(ClothWeaveArray, XColorArray,
YColorArray, 2, 2, 1, 1)

#declare ClothNormal1=
MakeClothNormal(ClothWeaveArray, 2, 2, 1, 1)

#declare ClothTexture1=
texture
{
    pigment{ ClothPigment1 }

	normal { ClothNormal1 }

    finish
    {
        diffuse 1
        ambient 0
    }
}


/*************************************************************
  Second Texture
**************************************************************/

#declare XColorArray = array[1]
{
    Blue
}

#declare YColorArray = array[1]
{
    White
}
    
    
#declare ClothWeaveArray = array[12][9]
{
    {1, 0, 0, 1, 0, 0, 1, 0, 0},
    {0, 1, 1, 1, 1, 1, 1, 1, 1},
    {1, 1, 1, 1, 1, 1, 1, 1, 0},
    {0, 1, 1, 1, 1, 1, 1, 1, 1},
    {1, 1, 1, 0, 0, 0, 1, 1, 0},
    {0, 1, 1, 0, 0, 0, 1, 1, 1},
    {1, 1, 1, 0, 0, 0, 1, 1, 0},
    {0, 1, 1, 0, 0, 0, 1, 1, 1},
    {1, 1, 1, 1, 1, 1, 1, 1, 0},
    {0, 1, 1, 1, 1, 1, 1, 1, 1},
    {1, 1, 1, 1, 1, 1, 1, 1, 0},
    {0, 1, 1, 0, 1, 1, 0, 1, 1}
}
    

#declare ClothPigment2=
MakeClothPigment(ClothWeaveArray, XColorArray,
YColorArray, 2, 2, 1, 1);

#declare ClothNormal2=
MakeClothNormal(ClothWeaveArray, 2, 2, 1, 1)

#declare ClothTexture2=
texture
{
    pigment{ ClothPigment2 }

	normal { ClothNormal2 }

    finish
    {
        diffuse 1
        ambient 0
    }
}


/*************************************************************
  Third Texture
**************************************************************/

#declare XColorArray = array[16]
{
    Orange,
    Orange,
    Orange,
    Orange,
    White,
    White,
    White,
    White,
    Green*0.5,
    Green*0.5,
    Green*0.5,
    Green*0.5,
    White,
    White,
    White,
    White
}

#declare YColorArray = array[16]
{
    Orange,
    Orange,
    Orange,
    Orange,
    White,
    White,
    White,
    White,
    Green*0.5,
    Green*0.5,
    Green*0.5,
    Green*0.5,
    White,
    White,
    White,
    White
}
    
    
#declare ClothWeaveArray = array[16][16]
{
    {1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0},
    {0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1},
    {1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0},
    {0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1},
    {1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0},
    {0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1},
    {1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0},
    {0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1}
    {1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0},
    {0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1}
    {1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0},
    {0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1}
    {1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0},
    {0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1}
    {1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0},
    {0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1}
}
    

#declare ClothPigment3=
MakeClothPigment(ClothWeaveArray, XColorArray,
YColorArray, 4, 4, 1, 1);

#declare ClothNormal3=
MakeClothNormal(ClothWeaveArray, 4, 4, 1, 1)

#declare ClothTexture3=
texture
{
    pigment{ ClothPigment3 }

	normal { ClothNormal3 }

    finish
    {
        diffuse 1
        ambient 0
    }
}


/*************************************************************
  Now set up three objects and use the three textures
**************************************************************/

 
sphere
{
    0,
    1

    texture
    {
        uv_mapping
        ClothTexture1
        scale 0.05
    }

    rotate -10*x
    rotate -28*z
    translate <-2, 1, 1>
}


box
{
    0, 1

    texture
    {
        uv_mapping

        ClothTexture2
		
		scale <1,1,0.1>
		
        scale 0.15
    }

    scale 2

    rotate 47*y

    translate <1, 0, 3>

}

bicubic_patch 
{ 
    type 1 
    flatness 0.001 
    u_steps 4 
    v_steps 4
    
    uv_vectors <0,0> <1,0> <1,1> <0,1> 
    
    <0,0,0>, <1,0,0>, <2,0,0>, <3,0,0>,
    <0,0,1>, <1,0,1>, <2,0,1>, <3,0,1>,
    <0,0,2>, <1,0,2>, <2,0,2>, <3,0,2>,
    <0,0,3>, <1,0,3>, <2,0,3>, <3,0,3>
    
    texture 
    { 
        uv_mapping
        
        pigment{ ClothPigment3 }

		normal
		{
			average
			
			normal_map
			{
				[ 1 ClothNormal3 scale <1,1,0.3>]
				[ 1 bumps 0.3 ]
			}
		}

        scale 0.05
	}

	
    translate <0, 0.001, 0>

    rotate -33*y

    scale 2

    translate<0,0,-0.8>

}
    

plane
{
    -z, -8

    texture
    {

        pigment
        {
			gradient x

			color_map
			{
            	[ 0 rgb<0.8, 0.7, 0.6> ]
				[ 1 rgb<0,0,0> ]
			}

			scale 18

			translate -6*x
        }

        finish
        {
            diffuse 1
        }

        normal
        {
            crackle 0.01 scale 0.01
        }
    }

    rotate -10*y
}


plane
{
    y, -0.01

    texture
    {
		pigment{ color rgb<0.5, 0.5, 0.4> }

        finish
        {
            diffuse 1
        }

        normal
        {
            bumps 0.01 scale 0.0001
        }
    }
}


// vim:textwidth=75:tabstop=4:shiftwidth=4:expandtab
// End of file clothtex.pov
